﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using CodeCamp_2011_ProSkills_Project.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using CodeCamp_2011_ProSkills_Project.Models.Dal;
using System.Security.Principal;
namespace CodeCamp_2011_ProSkills_Project.Controllers
{

    public class ChatController : Controller
    {
        private SkillContext db = new SkillContext();

        public const int MaxHistoryCount = 100;
        public const int MaxWaitSeconds = 60;

        public static Dictionary<string, int> OldMessageCount = new Dictionary<string, int>();

        public JsonResult ResetView()
        {
            string session = Session.SessionID;
            if (OldMessageCount.ContainsKey(session))
            {
                OldMessageCount[session] = 0;
            }
            else
            {
                OldMessageCount.Add(session, 0);
            }
            return Json(new
            {
                sessionId = session
            });
        }

        public JsonResult GetMessages(int course, string session)
        {
            Course courseEntity =
                (from c in db.Courses
                 where c.id == course
                 select c).SingleOrDefault();
            List<ChatMessage> messages = 
                (from message in db.Messages
                 where message.Course.id == courseEntity.id
                 select message).ToList();

            if (session != null && OldMessageCount.ContainsKey(session))
            {
                if (messages.Count > OldMessageCount[session])
                {
                    foreach (ChatMessage chatMessage in messages)
                    {
                        chatMessage.PrintablePostTime = chatMessage.PostTime.ToLongTimeString() + " " + chatMessage.PostTime.ToShortDateString();
                    }
                    OldMessageCount[session] = messages.Count;
                    messages.Reverse();
                    return Json(new
                    {
                        messages = messages
                    });
                }
            }
            else if (session != null)
            {
                OldMessageCount.Add(session, 0);
            }
            return null;
        }


        [HttpPost]
        public ActionResult New(int course, string msg)
        {
            Course courseEntity =
                   (from c in db.Courses
                    where c.id == course
                    select c).SingleOrDefault();
            AddMessage(courseEntity, msg);
            return Json(new
            {
                d = 1
            });
        }

        private void AddMessage(Course course, string message) 
        {
            User user =
                   (from u in db.Users
                    where u.userName == User.Identity.Name
                    select u).SingleOrDefault();
            if (user != null && message != "")
            {
                ChatMessage newMessage = new ChatMessage();
                newMessage.PostTime = System.DateTime.Now;
                newMessage.UserName = user.userName;
                newMessage.Course = course;
                newMessage.Message = message;
                db.Messages.Add(newMessage);
                db.SaveChanges();
            }
        }
    }
}
