﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using CodeCamp_2011_ProSkills_Project.Models.Dal;
using CodeCamp_2011_ProSkills_Project.Models;

namespace CodeCamp_2011_ProSkills_Project.Controllers
{
    public class UserViewController : Controller
    {
        private SkillContext db = new SkillContext();

        public ActionResult Index()
        {
            string username = System.Web.HttpContext.Current.User.Identity.Name;

            var user =
                (from users in db.Users
                 where users.userName == username
                 select users).SingleOrDefault();

            //if (!string.IsNullOrEmpty(username)) {
              //  user = user.Where(x => x.userName.StartsWith(username));
            //}


            ViewData["CurrentUser"] = user;
            ViewBag.currentUser = user;
            if (user == null)
            {
                return RedirectToAction("Index", "Home");
            }
            return View();
        }

        public ICollection<CourseEnrollment> getPassedCources()
        {
            List<CourseEnrollment> enrollments =
                (from c in db.CourseEnrollment
                 where c.User.userName == System.Web.HttpContext.Current.User.Identity.Name && c.Grade != 0
                 select c).ToList();

            return enrollments;
        }

        public ICollection<CourseEnrollment> getUserOngoingCourses()
        {
            List<CourseEnrollment> enrollments =
                (from c in db.CourseEnrollment
                 where c.User.userName == System.Web.HttpContext.Current.User.Identity.Name && c.Grade == 0
                 select c).ToList();

            return enrollments;
        }

        [HttpGet]
        public ActionResult CourseList()
        {
            if(Request.IsAjaxRequest())
            {
                ICollection<CourseEnrollment> passedCources = getPassedCources();
                ViewData["Courses"] = passedCources;
                return PartialView("_PassedCourses", passedCources);
            }
            return null;
        }

        [HttpGet]
        public ActionResult OngoingCourseList()
        {
            if (Request.IsAjaxRequest())
            {
                ICollection<CourseEnrollment> OngoingCources = getUserOngoingCourses();
                return PartialView("_OngoingCourseList", OngoingCources);
            }
            return null;
        }

    }
}
